/**
 * Divisione tra interi:
 * "quante volte y sta in x?"
 * Esempi: 
 * quoziente(13, 4) restituisce 3
 * quoziente(4, 13) restituisce 0
 *
 * Idea per la ricorsione.
 * Caso base: se x < y il quoziente della divisione intera tra x e y e' 0
 *   (in altre parole: y non sta in x nemmeno una volta)
 * Passo ricorsivo: se x >= y il quoziente della divisione intera tra x e y e'
 *   1 piu' il quoziente della divisione intera tra (x-y) e y
 *   (in altre parole: y sta in x una volta piu' tutte le volte per cui y sta in x-y)
 */

#include <stdio.h>

// ============================================================================

int leggi(void);
int quoziente( int a, int b );

// ============================================================================

int main(void) {
  int x = leggi();
  int y = leggi();
  int q = quoziente(x, y);
  printf( "Il quoziente di %i diviso %i e' %i.\n", x, y, q );
  return 0;
}

/* Funzione che chiede all'utente un numero positivo,
 * in caso continua a chiederlo.
 */
int leggi(void) {
  int numero;
  
  do {
    printf("inserisci un numero positivo: ");
    scanf("%d", &numero);
  } while (numero < 0);

  return numero;
}


int quoziente(int x, int y) {
  if (x < y)
    return 0;
  else
    return 1 + quoziente(x-y, y);
}
