/**
 * Idea per la ricorsione.
 * Caso base: se il valore e' composto da una sola cifra,
 *   il massimo e' la cifra stessa.
 * Passo ricorsivo: se il valore (n) e' composto da piu' cifre,
 *   isoliamo la cifra meno significativa (n % 10), calcoliamo 
 *   ricorsivamente il massimo sulle altre cifre (n / 10) e lo 
 *   confrontiamo con la cifra meno significativa.
 */

#include <stdio.h>

/* calcola il massimo tra due interi
 */
int max(int n, int m) {
  return n >= m ? n : m;
}

int cifra_massima(int num) {
  if (num < 10) // caso base: una cifra
    return num;
  else // passo ricorsivo: isoliamo la cifra meno significativa e richiamiamo sulle altre cifre
    return max(cifra_massima(num / 10), num % 10); 
}

int main(void) {
  int n;

  do {
    printf("Inserisci un numero non negativo: ");
    scanf("%d", &n);
  }
  while (n < 0);

  printf("La cifra massima di %i e' %i\n", n, cifra_massima(n));

  return 0;
}
